#!c:\usr\bin\python.exe

#
# ShicksAdmin.py 0.9
#                                                                      
# Copyright (C) 2001 Gerson Kurz
# 
# This program is free software; you can redistribute it and/or modify 
# it under the terms of the GNU General Public License as published by 
# the Free Software Foundation; either version 1, or (at your option)  
# any later version.                                                   
#                                                                      
# This program is distributed in the hope that it will be useful,      
# but WITHOUT ANY WARRANTY; without even the implied warranty of       
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        
# GNU General Public License for more details.                         
#                                                                      
# You should have received a copy of the GNU General Public License    
# along with this program; if not, write to the Free Software          
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.            
#

import cgi, sys, os, string, time, traceback
import binascii, rotor, maildb, re, copy, smtplib

from ShicksConfig import GetConfigSettings

import ShicksUser # user management

print "Content-type: text/html\n"
print '<html>'
print '<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">'
print '<meta http-equiv="expires" content="0">'
print '<meta http-equiv="pragma" content="no-cache">'
print '<link rel="stylesheet" type="text/css" href="/style/formate.css">'

class fehler:
    def write(self,x):
        print '<font size="4" color="#FF0000"><b>',x,"</b></font><br>"

sys.stderr = fehler()

USE_ENCODED_URLS = 1

RELAY_SMTP_SERVER_NAME = GetConfigSettings("SmtpRelayServer","")

def MAP_ROOT_NAME(filename):
    return filename

    # if your cgi-bin access path to the mail files differs from the one in the database,
    # you can edit this function. In the example below, the local linux name is mapped
    # to a NT server share name. 

    if filename[:14] == "/usr/pergamon/":
        filename = "\\\\darkstar\\alles\\pergamon\\" + filename[14:].replace("/","\\")
    return filename

## ~~~~~~~~~~~~~~~~~~~~ Beginn der Datenbankroutinen ~~~~~~~~~~~~~~~~~~~~~~~~

def ConvertTextareaToHtml(t,stripleadingbrs=0):
    t = t.split('\n')
    for i in range(len(t)):
        w = t[i]
        if len(w):
            if w[-1] == '\r':
                t[i] = w[:-1]
        if (i+1) < len(t):
            t[i] = t[i]+'<br>'
    if stripleadingbrs:
        x = t[-1]
        while len(x)>5 and (x[-4:] == '<br>'):
            x = x[:-4]
        t = string.join(t,'')
        while 1:
            x = t.find('<br><br>')
            if x >= 0:
                t = t[:x] + t[x+4:]
            else:
                break
        return t                
            
    return string.join(t,'')

def ConvertHtmlToTextarea(t):
    while 1:
        index = t.find('<br>')
        if index >= 0:
            t = t[:index] + '\n' + t[index+4:]
        else:
            break
    return t

## ~~~~~~~~~~~~~~~~~~ Ende der Datenbank-Routinen ~~~~~~~~~~~~~~~~~~
def SetFocus(func):
    return '<script>function setfocus() { document.f.'+func+'.focus(); }</script><body onLoad=setfocus()>'

def GenerateLinkData(action=None,userid=None,addressid=None):
    global args
    a = copy.copy(args)
    if action is not None:
        a['action'] = action
    a['userid'] = userid
    a['addressid'] = addressid
    s = str(a)
    global USE_ENCODED_URLS
    if USE_ENCODED_URLS:
        return binascii.b2a_hex(s)
    else:
        return s
    
def GenerateLink(action=None,userid=None,addressid=None):
    return "/cgi-bin/ShicksAdmin.py?code=%s" % GenerateLinkData(action,userid,addressid)
    
def strptime(x):
    x = map(int,re.compile('\.|\:|\ ').split(x))
    return time.mktime((x[2],x[1],x[0],x[3],x[4],x[5],0,0,0,))   

def GenerateTitlePage():
    global args
    top,bottom = 'navbar','errorlist'

    print '''<title>Shicks! Administration</title><body>
<h1>Shicks! Administration</h1>
<p>Welcome to the Shicks! Administration program. Version: 0.9</p>

<p>
[<a href="%s"> User management </a>]
[<a href="%s"> Configuration </a>]

</p>
</body></html>''' % (GenerateLink('ListAllUsers'),GenerateLink('SiteConfiguration'))

def ListAllUsers():
    usersdict = ShicksUser.GetUserDict()
    print '''<body><h1>Shicks! Users</h1>
<p>On this system, the following users are configured:</p>
<table border="1" width="100%">
  <tr>
    <td width="50%"><b>Name</b></td>
    <td width="10%"><b>Mails</b></td>
    <td width="10%"><b>Bytes</b></td>
    <td width="30%"><b>Action</b></td>
  </tr>'''
    for userid in usersdict.keys():
        user = usersdict[userid]
        nr_of_mails = maildb.DbQuery("SELECT COUNT(*),SUM(MSGLEN) FROM messages WHERE UID=%d AND DELETED=0" % userid)

        nr_of_mails, bytes_used = nr_of_mails[0]
        if not bytes_used: bytes_used = 0
        else: bytes_used = int(bytes_used)
        print '''<tr>
    <td width="50%%">%s</td>
    <td width="10%%">%d</td>
    <td width="10%%">%d</td>
    <td width="30%%">[<a href="%s"> Messages </a>] [<a href="%s"> Edit </a>]
[<a href="%s"> Delete </a>] [<a href="%s"> Spam </a>]</td>
  </tr>''' % (user.getName(),nr_of_mails, bytes_used,
              GenerateLink('DisplayMessageRange',userid),
              GenerateLink('DescribeUserByID',userid),
              GenerateLink('DeleteUserByID',userid),
              GenerateLink('FilterSpam',userid))
    print '</table><p>'
    print '[<a href="%s"> Refresh </a>]' % GenerateLink('ListAllUsers')
    print '[<a href="%s"> Create a new user </a>]' % GenerateLink('CreateNewUser')
    print '[<a href="%s"> Create a mailing list </a>]' % GenerateLink('CreateMailingList')
    print '[<a href="%s"> Back to main page </a>]' % GenerateLink('mainframe')    
    print '</p></body></html>'

def CreateMailingList():
    print SetFocus("shortname"),'''<h1>Create mailing list</h1>
<form name="f" method="POST" action="ShicksAdmin.py">
<p>Name of mailing list: <input name="shortname" size="32"></p>
<p>Default E-Mail address: <input name="email" size="32"></p>
<p>Choose members of this list:</p>
<p><select size="19" name="D1" multiple>'''

    userlist = maildb.DbQuery("SELECT ID, MAIL FROM addresses ORDER BY MAIL")
    for user in userlist:
        print '<option value="%d">%s</option>' % (user[0],user[1])
    print '</select></p><p><input type="submit" value="Submit" name="B1"></p>'
    print '<INPUT type=hidden value="%s" name=code>' % GenerateLinkData("CreateMailingListOK")
    print '<p>[<a href="%s"> Go back to user list </a>]</p>' % GenerateLink('ListAllUsers')
    print '</form></html>'

def GetHtmlString(body):
    body = body.replace("<","&lt;");
    body = body.replace(">","&gt;");
    return body

def ReadMessageBody(filename):
    result = { 'Von':'???', 'An':'???', 'Title':'???' }
    try:
        for line in open(MAP_ROOT_NAME(filename)).read(2000).split("\n"):
            if line[:5].lower() == "from:":
                result["Von"] = GetHtmlString(line[5:].strip())
            elif line[:3].lower() == "to:":
                result["An"] = GetHtmlString(line[3:].strip())
                if len(result["An"]) > 50:
                    result["An"] = result["An"][:50] + "..."
                if result["An"] == "":
                    result["An"] = "&nbsp;"
            elif line[:8].lower() == "subject:":
                result["Title"] = GetHtmlString(line[8:].strip())
                if result["Title"] == "":
                    result["Title"] = "&nbsp;"
                if len(result["Title"]) > 50:
                    result["Title"] = result["Title"][:50] + "..."
    except:
        pass
    return result

def ShowPlainTextMessage():
    userid, name = GetUserSpecificSettings()
    msgid = args["addressid"]
    message = maildb.DbQuery("SELECT BODY FROM messages WHERE ID=%d" % msgid)

    print '<p>Message %d from file <font face="Courier New" color="#0055FF">%s</font></p>' % (msgid, message[0][0])
 
    print SetFocus("MailTo"),'''<form name="f" method="POST" action="ShicksAdmin.py">
<p><input type="submit" value="Delete this message" name="DeleteMessage">
<input type="submit" value="Resend this message to" name="ResendMessage">
<input name="MailTo" size="50" value=""> this e-mail address.</p>
<INPUT type=hidden value="%s" name=code>
</form></html>''' % (GenerateLinkData("ResendOrDeleteMessage",userid,msgid))
    
    print "<hr><pre>"
    print GetHtmlString(open(MAP_ROOT_NAME(message[0][0])).read())
    print "</pre><hr></body></html>"

def GenerateYesNoQuestion(messagebody,question,action_yes,action_no):    
    print '<title>Question</title><p>',messagebody,'</p>'
    print '<hr><h2>', question
    print '<a href=%s>Yes</a>&nbsp;' % action_yes
    print '<a href=%s>No</a></font></h2>' % action_no
    print '<p><b>Warning:</b> You cannot recover messages once they have been deleted.</p>'
    print '</body></html>'
    
def ResendOrDeleteMessage():
    userid = args["userid"]
    msgid = args["addressid"]
    if form.has_key("DeleteMessage"):
        message = maildb.DbQuery("SELECT BODY FROM messages WHERE ID=%d" % msgid)
        message = GetHtmlString(open(MAP_ROOT_NAME(message[0][0])).read())
        if len(message) > 1000:
            message = message[:1000] + "..."
        message = "<pre>\n" + message + "\n</pre>\n"      
        GenerateYesNoQuestion(message,"Are you sure you want to delete this message?",
                              GenerateLink("DeleteMessageOK",userid,msgid),
                              GenerateLink("ShowPlainTextMessage",userid,msgid))
    elif form.has_key("ResendMessage"):
        target_address = str(form["MailTo"].value)
        filename = maildb.DbQuery("SELECT BODY FROM messages WHERE ID=%d" % msgid)[0][0]
        sender_address = maildb.DbQuery("SELECT MAIL FROM addresses WHERE UID=%d" % userid)[0][0]
        body = open(MAP_ROOT_NAME(filename)).read()
        server = smtplib.SMTP(RELAY_SMTP_SERVER_NAME)
        server.sendmail(sender_address, (target_address,), body)
        server.quit()
        print "message has been sent to", target_address        
        ShowPlainTextMessage()

def DeleteMessageOK():
    msgid = args["addressid"]
    body = maildb.DbQuery("SELECT BODY FROM messages WHERE ID=%d" % msgid)
    os.remove(body[0][0])
    maildb.DbCommit("DELETE FROM messages WHERE ID=%d" % msgid)
    DisplayMessageRange()

def DisplayMessageRange():
    userid = args["userid"]    
    lines = 30
    if form.has_key("AnzahlZeilen"):
        z = int(form["AnzahlZeilen"].value)
        if z:
            lines = z

    startindex = 0
    if form.has_key("StartIndex"):
        startindex = int(form["StartIndex"].value)

    msgcount = maildb.DbQuery("SELECT COUNT(*) FROM messages WHERE UID=%d" % userid)[0][0]

    max_msgstart = msgcount-lines
    if max_msgstart < 0:
        max_msgstart = 0
        
    if form.has_key("ButtonAnfang"):
        args["range"] = (0, lines)
        DisplayMessagesForList()
    elif form.has_key("ButtonEnde"):
        args["range"] = (max_msgstart, lines)
        DisplayMessagesForList()
    elif form.has_key("ButtonWeiter"):
        msgstart = startindex + lines
        if msgstart > max_msgstart:
            msgstart = max_msgstart
        args["range"] = (msgstart, lines)
        DisplayMessagesForList()
    elif form.has_key("ButtonVorher"):
        msgstart = startindex - lines
        if msgstart < 0:
            msgstart = 0
        args["range"] = (msgstart, lines)
        DisplayMessagesForList()
    else: # form.has_key("ButtonRefresh")
        args["range"] = (startindex, lines)
        DisplayMessagesForList()
        
def DisplayMessagesForList():
    range = (0,30)
    if args.has_key("range"):
        range = args["range"]
    userid, name = GetUserSpecificSettings()
    print '<body><h1>Messages for %s</h1>' % name

    print SetFocus("AnzahlZeilen"),'''<form name="f" method="POST" action="ShicksAdmin.py"><p>
<input type="submit" value="|< Start" name="ButtonAnfang">
<input type="submit" value="< Previous" name="ButtonVorher">
<input type="submit" value="Show" name="ButtonRefresh">
<input name="AnzahlZeilen" size="5" value="%d"> Messages,
starting with <input name="StartIndex" size="5" value="%d">
<input type="submit" value="> Next" name="ButtonWeiter">
<input type="submit" value=">| End" name="ButtonEnde">
<INPUT type=hidden value="%s" name=code>
</form>''' % (range[1],range[0],GenerateLinkData("DisplayMessageRange",userid))
    print '[<a href="%s"> Go back to user list </a>]</p>' % GenerateLink("ListAllUsers")

    messages = maildb.DbQuery("SELECT * FROM messages WHERE UID=%d ORDER BY CREATED LIMIT %d, %d" % (userid,range[0],range[1]))

    print '''<table border="1" width="100%">
  <tr>
    <td width="10%" bgcolor="#99CCFF"><b>From</b></td>
    <td width="10%" bgcolor="#99CCFF"><b>To</b></td>
    <td width="55%" bgcolor="#99CCFF"><b>Title</b></td>
    <td width="5%" bgcolor="#99CCFF"><b>Size</b></td>
    <td width="10%" bgcolor="#99CCFF"><b>Date</b></td>
    <td width="10%" bgcolor="#99CCFF"><b>Status</b></td>
  </tr>'''
    bgcolor = "FFFFFF"
    for message in messages:
        body = ReadMessageBody(message[2])

        if message[4]:
            bgcolor = "DDDDDD"
        else:
            bgcolor = "FFFFFF"

        if message[6]:
            status = "sent"
        else:
            status = "received"

        print '''<tr>
    <td width="10%%" bgcolor="#%s"><p>%s</p></td>
    <td width="10%%" bgcolor="#%s"><p>%s</p></td>
    <td width="55%%" bgcolor="#%s"><p><a href="%s">%s</a></p></td>
    <td width="5%%" bgcolor="#%s"><p align="right">%d</p></td>
    <td width="10%%" bgcolor="#%s"><p align="right">%s</p></td>
    <td width="10%%" bgcolor="#%s"><p align="right">%s</p></td>
  </tr>'''% (bgcolor, body["Von"], bgcolor, body["An"], bgcolor,
             GenerateLink("ShowPlainTextMessage",userid,message[0]), body["Title"],
             bgcolor, message[3], bgcolor, message[5], bgcolor, status)
    print '</table>'

    
    #for message in messages:
    #    print "<p>", message, "</p>"
        
def GoBackToUserList(formname=None):
    print '<p>'
    if formname:
        print '[<a href="%s"> Go back to form </a>] ' % GenerateLink(formname,args["userid"]),
        
    print '[<a href="%s"> Go back to user list </a>]</p>' % GenerateLink('ListAllUsers')

def GoBackToUserInfo(formname=None):
    print '<p>'
    if formname:
        print '[<a href="%s"> Go back to form </a>] ' % GenerateLink(formname,args["userid"]),
        
    print '[<a href="%s"> Go back to user info </a>]</p>' % GenerateLink('DescribeUserByID',args["userid"])

def CreateMailingListOK():

    shortname,emailaddr = "",""
    if form.has_key('shortname'):
        shortname = form['shortname'].value
    if form.has_key('email'):
        emailaddr = form['email'].value

    if not shortname:
        print "<body><h1>Error, name cannot be empty</h1>"
        return GoBackToUserList('CreateMailingList')

    # check if the name already exists
    user = ShicksUser.GetUserByName(shortname)
    if user:
        print "<body><h1>Error, name already in use</h1>"
        return GoBackToUserList('CreateMailingList')

    # if an address is given
    if not emailaddr:
        print "<body><h1>Error, e-mail address cannot be empty</h1>"
        return GoBackToUserList('CreateMailingList')
        
    result = maildb.DbQuery("SELECT ID FROM addresses WHERE MAIL='%s'" % emailaddr)
    if len(result):
        print "<body><h1>Error, e-mail address already in use</h1>"
        return GoBackToUserList('CreateMailingList')

    # create mailing list
    ShicksUser.CreateNewUser(shortname,'')

    user = ShicksUser.GetUserByName(shortname)
    if not user:
        print "<body><h1>Error, unable to add user to database</h1>"
        return GoBackToUserList('CreateMailingList')
    userid = user.getId()

    # add default e-mail address
    if emailaddr:
        maildb.DbCommit("INSERT INTO addresses (UID,MAIL) VALUES (%d,'%s')" % (userid,emailaddr))

    if form.has_key('D1'):
        f = form['D1']
        if type(form) in (type((0,)), type([])):
            for k in f:
                IAddListMember(userid,int(k.value))
        else:
            IAddListMember(userid,int(f.value))

    print "<p>OK, the mailing list has been created successfully.</p>"
    return GoBackToUserList()

def CreateNewUser():
    print SetFocus("shortname"),'''<h1>Create new user</h1>
<form name="f" method="POST" action="ShicksAdmin.py">'''

    print '<table border="0" width="100%">'
    print '''<tr><td bgcolor="#eeeeff" width="20%" align="right">User name (used for login): </td>
<td bgcolor="#eeeeee" width="80%"><input name="shortname" size="32"></td></tr>'''

    print '''<tr><td bgcolor="#eeeeff" width="20%" align="right">Please enter a password: </td>
<td bgcolor="#eeeeee" width="80%"><input type="password" name="T1" size="20"></td></tr>'''

    print '''<tr><td bgcolor="#eeeeff" width="20%" align="right">Please enter password again: </td>
<td bgcolor="#eeeeee" width="80%"><input type="password" name="T2" size="20"></td></tr>'''

    print '''<tr><td bgcolor="#eeeeff" width="20%" align="right">Please enter an e-mail address: </td>
<td bgcolor="#eeeeee" width="80%"><input name="email1" size="50"></td></tr>'''
    
    print '</table>'
    
    print '<INPUT type=hidden value="%s" name=code>' % GenerateLinkData("CreateNewUserOK")
    print '<p><input type="submit" value="Submit" name="B1"></p>'   
    print '<p>[<a href="%s"> Go back to user list </a>]</p>' % GenerateLink('ListAllUsers')
    print '</form></html>'

def CreateNewUserOK():
    # retrieve passwords
    shortname,fullname,pwd1,pwd2 = "","","",""
    if form.has_key('shortname'):
        shortname = form['shortname'].value
    if form.has_key('T1'):
        pwd1 = form['T1'].value
    if form.has_key('T2'):
        pwd2 = form['T2'].value

    # check if the name already exists
    user = ShicksUser.GetUserByName(shortname)

    if not shortname:
        print "<body><h1>Error, username cannot be empty</h1>"
    elif user:
        print "<body><h1>Error, username already in use</h1>"
    elif pwd1 != pwd2:
        print "<body><h1>Error, both passwords must match</h1>"
    else:
        ShicksUser.CreateNewUser(shortname, pwd1)

        if form.has_key('email1'):
            email1 = form['email1'].value
            user = ShicksUser.GetUserByName(shortname)
            if user:
                new_user_id = user.getId()
                maildb.DbCommit("INSERT INTO addresses (UID,MAIL) VALUES (%d,'%s')" % (new_user_id, maildb.EscapeSqlString(email1)))
                print "<body><H1>OK, user %s with e-mail %s created</h1>" % (shortname, email1)
            else:
                print "<body><H1>ERROR, user %s wasn't created successfully, please check the logfiles.</h1>"
                
        else:
            print "<body><H1>OK, user %s created</h1>" % shortname
    print '<p><a href="%s">Go back to user list</a></p>' % GenerateLink('ListAllUsers')
    
def AddEmailForUserID():
    userid, name = GetUserSpecificSettings()
    
    print SetFocus('T1'), '<h1>Add e-mail address for %s</h1>' % name
    print '<form name="f" method="POST" action="ShicksAdmin.py">'
    print '<p>E-Mail address: <input name="T1" size="50"></p>'
    print '<p><input type="submit" value="Submit" name="B1"></p>'
    print '<INPUT type=hidden value="%s" name=code>' % GenerateLinkData("AddEmailForUserIDOK",userid)
    print '<p>[<a href="%s"> Go back to user info </a>]' % (GenerateLink('DescribeUserByID',userid))
    print '</form></html>'

def AddEmailForUserIDOK():
    userid, name = GetUserSpecificSettings()

    address = form['T1'].value

    # check if this address is in use
    inuse = maildb.DbQuery("SELECT ID FROM addresses WHERE mail='%s'" % address)
    if inuse:
        print "<body><h1>Error, address is already in use</h1>"
    else:
        maildb.DbCommit("INSERT INTO addresses (UID,MAIL) VALUES (%d,'%s')" % (userid,address))
        print "<body><p>OK, e-mail has been added.</p>"
    print '<p>[<a href="%s"> Go back to user info </a>]</p>' % (GenerateLink('DescribeUserByID',userid))

def AddMailingListMember():
    userid, name = GetUserSpecificSettings()
    
    print SetFocus('T1'), '<h1>Add member(s) for mailing list %s</h1>' % name
    print '<form name="f" method="POST" action="ShicksAdmin.py">'
    print '<p>E-Mail address: <input name="T1" size="50">'
    print '<br>or choose members in the list of local users:<br><select size="10" name="D1" multiple>'

    addresslist = maildb.DbQuery("SELECT ID, MAIL FROM addresses ORDER BY MAIL")
    for address in addresslist:        
        print '<option value="%d">%s</option>' % tuple(address)
    
    print '</p>'
    print '<p><input type="submit" value="Submit" name="B1"></p>'
    print '<INPUT type=hidden value="%s" name=code>' % GenerateLinkData("AddMailingListMemberOK",userid)
    print '<p>[<a href="%s"> Go back to mailing list info </a>]' % GenerateLink('DescribeUserByID',userid)
    print '</form></html>'

def IAddListMember(UID,AID):
    temp = maildb.DbQuery("SELECT ID FROM forwardmail WHERE UID=%d AND AID=%d" % (UID,AID))
    if not len(temp):
        maildb.DbCommit("INSERT INTO forwardmail (UID,AID) VALUES (%d,%d)" % (UID,AID))

def AddMailingListMemberOK():
    userid, name = GetUserSpecificSettings()

    # check if this address is in use
    if form.has_key('T1'):
        address = form['T1']
        inuse = maildb.DbQuery("SELECT ID FROM addresses WHERE mail='%s'" % address)
        if not inuse:
            temp = maildb.DbCommit("INSERT INTO addresses (MAIL) VALUES ('%s')" % address)
            inuse = maildb.DbQuery("SELECT ID FROM addresses WHERE mail='%s'" % address)
        IAddListMember(userid,inuse[0][0])

    if form.has_key('D1'):
        d1 = form['D1']
        if type(d1) == type([]):
            for single_address in d1:
                IAddListMember(userid,int(single_address.value))
        else:
            IAddListMember(userid,int(d1.value))

    print "<body><p>OK, member(s) have been added.</p>"
    print '<p>[<a href="%s"> Go back to mailing list </a>]</p>' % GenerateLink('DescribeUserByID',userid)

def ChangeEmailAddress():
    userid, name = GetUserSpecificSettings()

    address = maildb.DbQuery("SELECT MAIL FROM addresses WHERE ID=%d" % args["addressid"])[0]
    
    print SetFocus('T1'), '<h1>Change e-mail address</h1>' 
    print '<form name="f" method="POST" action="ShicksAdmin.py">'
    print '<p>E-Mail address: <input name="T1" size="50" value="%s"></p>' % address[0]
    print '<p><input type="submit" value="Submit" name="B1"></p>'
    print '<INPUT type=hidden value="%s" name=code>' % GenerateLinkData("ChangeEmailAddressOK",userid,addressid=args["addressid"])
    print '<p>[<a href="%s"> Go back to user info </a>]' % (GenerateLink('DescribeUserByID',userid))
    print '</form></html>'

def ChangeEmailAddressOK():
    userid, name = GetUserSpecificSettings()
    address = form['T1'].value

    # check if this address is in use
    inuse = maildb.DbQuery("SELECT ID FROM addresses WHERE mail='%s'" % address)
    if inuse:
        print "<body><h1>Error, address is already in use</h1>"
    else:
        maildb.DbCommit("UPDATE addresses SET MAIL='%s' WHERE ID=%d" % (address,args["addressid"]))
        print "<body><p>OK, e-mail address has been changed.</p>"
    print '<p>[<a href="%s"> Go back to user info </a>]</p>' % (GenerateLink('DescribeUserByID',userid))

def DeleteEmailAddress():
    address = maildb.DbQuery("SELECT MAIL FROM addresses WHERE ID=%d" % args["addressid"])[0]
    
    print '<bod><h2>Are you sure you want to delete e-mail address %s</h2><p>' % address[0]
    print '[<a href="%s"> OK </a>]' % GenerateLink("DeleteEmailAddressOK",args["userid"],addressid=args["addressid"])
    print '[<a href="%s"> Cancel </a>]' % GenerateLink('DescribeUserByID',args["userid"])
    print '</p></form></html>'

def DeleteEmailAddressOK():
    userid, name = GetUserSpecificSettings()

    addressid = args["addressid"]    

    maildb.DbCommit("DELETE FROM forwardmail WHERE AID=%d" % addressid)
    maildb.DbCommit("DELETE FROM addresses WHERE ID=%d" % addressid)

    print '<p>E-Mail address has been deleted, and all references purged.</p>'
    print '<p>[<a href="%s"> Go back to user info </a>]</p>' % (GenerateLink('DescribeUserByID',userid))

def DeleteUserByID():
    userid, name = GetUserSpecificSettings()
    
    print '<bod><h2>Are you sure you want to delete %s</h2><p>' % name
    print '[<a href="%s"> OK </a>]' % GenerateLink("DeleteUserByIDOK",args["userid"])
    print '[<a href="%s"> Cancel </a>]' % GenerateLink('DescribeUserByID',args["userid"])
    print '</p></form></html>'

def DeleteUserByIDOK():
    userid, name = GetUserSpecificSettings()

    maildb.DbCommit("DELETE FROM forwardmail WHERE UID=%d" % userid)

    addresses_used = maildb.DbQuery("SELECT ID FROM addresses WHERE UID=%d" % userid)
    for address in addresses_used:
        maildb.DbCommit("DELETE FROM forwardmail WHERE AID=%d" % address[0])
    
    maildb.DbCommit("DELETE FROM addresses WHERE UID=%d" % userid)
    
    ShicksUser.DeleteUserByID(userid)

    print '<p>%s has been deleted, and all references purged.</p>' % name
    GoBackToUserList()

def RemoveForwardID():
    userid, name = GetUserSpecificSettings()
    
    print '<bod><h2>Are you sure you want to remove this forwarding entry ?</h2><p>'
    print '[<a href="%s"> OK </a>]' % GenerateLink("RemoveForwardIDOK",userid,addressid=args["addressid"])
    print '[<a href="%s"> Cancel </a>]' % GenerateLink('DescribeUserByID',userid)
    print '</p></form></html>'

def RemoveForwardIDOK():
    userid, name = GetUserSpecificSettings()

    maildb.DbCommit("DELETE FROM forwardmail WHERE UID=%d AND AID=%d" % (userid,args["addressid"]))

    print '<p>Forwarding entry has been removed.</p>'
    GoBackToUserInfo()

def AddUserForwardID():
    userid, name = GetUserSpecificSettings()
    
    print SetFocus('T1'), '<h1>Add e-mail forwarding for user %s</h1>' % name
    print '<form name="f" method="POST" action="ShicksAdmin.py">'
    print '<p>Forward to this e-mail address: <input name="T1" size="50"></p>'
    print '<p><input type="submit" value="Submit" name="B1"></p>'
    print '<INPUT type=hidden value="%s" name=code>' % GenerateLinkData("AddUserForwardIDOK",userid)
    print '<p>[<a href="%s"> Go back to user info </a>]' % GenerateLink('DescribeUserByID',userid)
    print '</form></html>'

def AddUserForwardIDOK():
    userid, name = GetUserSpecificSettings()

    if not form.has_key('T1'):
        print "<body><h1>Error, the user name cannot be empty</h1>"
        return GoBackToUserInfo('AddUserForwardID')

    email = form['T1'].value
    address = maildb.DbQuery("SELECT ID,UID FROM addresses WHERE MAIL='%s'" % email)
    if len(address):
        address = address[0]
        if address[1] == userid:
            print "<body><h1>Error, you cannot forward the mail to yourself!</h1>"
            return GoBackToUserInfo('AddUserForwardID')

        existing_forward = maildb.DbQuery("SELECT ID FROM forwardmail WHERE UID=%d AND AID=%d" % (userid,address[0]))
        if existing_forward:
            print "<body><h1>Error, this forwarding already exists!</h1>"
            return GoBackToUserInfo('AddUserForwardID')

    else:
        maildb.DbCommit("INSERT INTO addresses (UID,MAIL) VALUES (0,'%s')" % (email))
        address = maildb.DbQuery("SELECT ID,UID FROM addresses WHERE MAIL='%s'" % email)
        if not len(address):
            print "<body><h1>Error, unable to add forward address</h1>"
            return GoBackToUserInfo('AddUserForwardID')
        address = address[0]

    maildb.DbCommit("INSERT INTO forwardmail (UID,AID) VALUES (%d,%d)" % (userid,address[0]))
    print "<body><p>OK, e-mail forwarding has been created.</p>"
    return GoBackToUserInfo()

def ChangeNameForUserID():
    global args
    user = ShicksUser.GetUserByID(args['userid'])
    assert( user is not None )
    
    userid = user.getId()

    print SetFocus("T1"),'<h1>Change name for user %s</h1>' % user.getName()
    print '<form name="f" method="POST" action="ShicksAdmin.py">'
    print '<p>Name: <input name="T1" size="50" value="%s"></p>' % user.getName()
    print '<p><input type="submit" value="Submit" name="B1"></p>'
    print '<INPUT type=hidden value="%s" name=code>' % GenerateLinkData("ChangeNameForUserIDOK",userid)
    print '<p>[<a href="%s"> Go back to user info </a>]</p>' % GenerateLink('DescribeUserByID',userid)
    print '</form></html>'

def ChangeNameForUserIDOK():
    userid, name = GetUserSpecificSettings()

    # retrieve passwords
    shortname = ""
    if form.has_key('T1'):
        shortname = form['T1'].value

    if not shortname:
        print "<body><h1>Error, the user name cannot be empty</h1>"
        return GoBackToUserInfo('ChangeNameForUserID')

    # check if the name already exists
    user = ShicksUser.GetUserByName(shortname)
    
    if user:
        print "<body><h1>Error, there already exists an entry with this name</h1>"
        return GoBackToUserInfo('ChangeNameForUserID')

    user.setName(shortname)
    user.saveChanges()
    
    print "<body><p>OK, name has been changed.</p>"
    return GoBackToUserInfo()

def ChangePasswordForUserID():
    userid, name = GetUserSpecificSettings()
    
    print SetFocus('T1'),'<h1>Change password for user %s</h1>' % name
    print '<form name="f" method="POST" action="ShicksAdmin.py">'
    print '<p>Please enter a new password: <input type="password" name="T1" size="20"></p>'
    print '<p>Please enter password again: <input type="password" name="T2" size="20"></p>'
    print '<p><input type="submit" value="Submit" name="B1"></p>'
    print '<INPUT type=hidden value="%s" name=code>' % GenerateLinkData("ChangePasswordForUserIDOK",userid)
    print '<p>[<a href="%s"> Go back to user info </a>]</p>' % GenerateLink('DescribeUserByID',userid)
    print '</form></html>'

def ChangePasswordForUserIDOK():
    global args

    user = ShicksUser.GetUserByID(args["userid"])

    # retrieve passwords
    pwd1,pwd2 = "", ""
    if form.has_key('T1'):
        pwd1 = form['T1'].value
    if form.has_key('T2'):
        pwd2 = form['T2'].value

    if pwd1 != pwd2:
        print "<body><h1>Error, both passwords must match</h1>"
    else:
        user.setPassword(pwd1)
        user.saveChanges()
        print "<body><p>OK, password has been changed.</p>"
    print '<p>[<a href="%s"> Go back to user info </a>]</p>' % GenerateLink('DescribeUserByID',userid)
        
def GetUserSpecificSettings():
    user = ShicksUser.GetUserByID(args['userid'])
    return user.getId(), user.getName()

def DescribeUserByID():
    userid, name = GetUserSpecificSettings()
    addresslist = maildb.DbQuery("SELECT ID,MAIL FROM addresses WHERE UID=%d" % userid)
    
    print '<body><h1>Information for %s</h1>' % name

    # get statistics
    deleted_msgs = maildb.DbQuery("SELECT COUNT(*),SUM(MSGLEN) FROM messages WHERE UID=%d AND DELETED=0" % userid)[0]
    pending_msgs = maildb.DbQuery("SELECT COUNT(*),SUM(MSGLEN) FROM messages WHERE UID=%d AND DELETED=1" % userid)[0]

    def f(x):
        if x is None: return 0
        return int(x)

    deleted_msgs[1] = f(deleted_msgs[1])
    pending_msgs[1] = f(pending_msgs[1])

    total_msgs = [deleted_msgs[0]+pending_msgs[0],deleted_msgs[1]+pending_msgs[1]]

    print """<p>This user has received a total of %d messages using %d bytes,
from which %d messages (%d bytes) are still unread.</p><p>""" % (total_msgs[0], total_msgs[1],deleted_msgs[0],deleted_msgs[1])
    
    print '[<a href="%s"> Change name </a>]' % GenerateLink('ChangeNameForUserID',userid)
    print '[<a href="%s"> Change password </a>]' % GenerateLink('ChangePasswordForUserID',userid)
    print '[<a href="%s"> Delete this user </a>]' % (GenerateLink('DeleteUserByID',userid))
    print '</p>'

    ## ************ EMAIL ADDRESS LIST **********    
    print '<h3>E-Mail Address List</h3>'    
    if len(addresslist):
        print '<ul>'
        for address in addresslist:
            print '<li>%s [<a href="%s"> Edit </a>] [<a href="%s"> Delete </a>]</li>' % (address[1],
                                                                                           GenerateLink('ChangeEmailAddress',userid,addressid=address[0]),
                                                                                           GenerateLink('DeleteEmailAddress',userid,addressid=address[0]))
        print "</ul>"
    else:
        print '<p>No e-mail addresses defined for this user yet.</p>'
    
    print '[<a href="%s"> Add E-Mail address </a>]' % GenerateLink('AddEmailForUserID',userid)
    print '<h3>Forwarding</h3>'
    forwardlist = maildb.DbQuery("SELECT f.ID,a.ID,a.MAIL FROM forwardmail AS f, addresses AS a WHERE f.UID=%d and a.ID=f.AID" % userid)
    if len(forwardlist):
        print "<ul>"
        for entry in forwardlist:
            print '<li>%s [<a href="%s"> Edit </a>] [<a href="%s"> Remove </a>]</li>' % (entry[2],
                                                                                         GenerateLink('ChangeEmailAddress',userid,addressid=entry[1]),
                                                                                         GenerateLink('RemoveForwardID',userid,addressid=entry[1]))
        print "</ul>"
    else:
        print "<p>No forwarding addresses defined for this user.</p>"

    print '[<a href="%s"> Add E-Mail forwarder </a>]' % GenerateLink('AddUserForwardID',userid)
    print '[<a href="%s"> Add mailing list members </a>]' % GenerateLink('AddMailingListMember',userid)

    ## ************ MISC COMMANDS LIST **********
    print '<h3>Misc commands</h3>'    
    print '[<a href="%s"> Refresh this page </a>]' % GenerateLink('DescribeUserByID',userid)
    print '[<a href="%s"> Back to users list </a>]' % GenerateLink('ListAllUsers')
    print '[<a href="%s"> Back to main page </a>]' % GenerateLink('mainframe')
    print '</ul></body></html>'

def SiteConfiguration():
    print '''<body><h1>Shicks! Settings</h1>
<p>On this system, the following settings are configured:</p>
<form name="f" method="POST" action="ShicksAdmin.py">'''

    # settings as from SMTPServer.py
    default_trace_directory = "/usr/share/shicks/log"
    default_mail_directory = "/usr/share/shicks/mail"
    if os.name == "nt":
        default_trace_directory = "c:\\shicks\\log"
        default_mail_directory = "c:\\shicks\\mail"
    
    TRACE_DIRECTORY = GetConfigSettings("Logfiles",default_trace_directory)
    RELAY_SMTP_SERVER_NAME = GetConfigSettings("SmtpRelayServer","")
    LOCAL_STORAGE = GetConfigSettings("LocalStorage",default_mail_directory)
    ADMIN_ACCOUNT = GetConfigSettings("AdminAccount","")
    LOCAL_DOMAIN = GetConfigSettings("LocalDomain","")
    UNKNOWN_LOCAL_ACCOUNT = GetConfigSettings("UnknownLocalAccount","")
    LOCAL_IP_RANGE = GetConfigSettings("LocalIpRange","")
    STRICT_RELAY_TEST = GetConfigSettings("StrictRelayTest","1")

    print '<table border="0" width="100%">'

    for item in (('Logfile directory','Logfiles',TRACE_DIRECTORY),
                 ('Relay SMTP server','SmtpRelayServer',RELAY_SMTP_SERVER_NAME),
                 ("Use relay STMP server always",'UseRelaySmtpServer',None),
                 ('Directory for mails','LocalStorage',LOCAL_STORAGE),
                 ('Admin account','AdminAccount',ADMIN_ACCOUNT),
                 ('Local domain','LocalDomain',LOCAL_DOMAIN),
                 ('Unknown account','UnknownLocalAccount',UNKNOWN_LOCAL_ACCOUNT),
                 ('Local IP-Range','LocalIpRange',LOCAL_IP_RANGE),
                 ('Strict relay test','StrictRelayTest',STRICT_RELAY_TEST),
                 ("Catch-all",'CatchAll',None),
                 ("Force SMTP auth",'RequireSmtpAuth',None),
                 ("Deny mails from these hosts",'DenyHostsList',None),
                 ("Blacklisted domains",'BlacklistDomains',None),
                 ("Domains ignored on blacklist",'BlacklistIgnore',None),
                 ("Physically delete mails after they have been fetched",'PhysicallyDeleteMails',None),
                 ):

        temp = list(item)
        if temp[2] is None:
            temp[2] = GetConfigSettings(temp[1],"")
        print '''<tr><td bgcolor="#eeeeff" width="20%%" align="right">%s: </td>
<td bgcolor="#eeeeee" width="80%%"><input name="%s" size="60" value="%s"></td></tr>''' % tuple(temp)
    print '</table>'
    print '</select></p><p><input type="submit" value="Submit" name="B1"></p>'
    print '<INPUT type=hidden value="%s" name=code>' % GenerateLinkData("SiteConfigurationOK")
    print '[<a href="%s"> Back to main page  </a>]' % GenerateLink('mainframe')    
    print '</p></body></html>'

def SetSingleConfigEntry(name,default_value=''):
    content = default_value
    if form.has_key(name):
        content = form[name].value
    content = maildb.EscapeSqlString(content)
    maildb.DbCommit("UPDATE settings SET VALUE='%s' WHERE VARIABLE='%s'" % (content,name))

def SiteConfigurationOK():
    for item in ('Logfiles','SmtpRelayServer','UseRelaySmtpServer','LocalStorage',
                'AdminAccount','LocalDomain','UnknownLocalAccount','LocalIpRange',
                'StrictRelayTest','CatchAll','RequireSmtpAuth','DenyHostsList',
                'BlacklistDomains','BlacklistIgnore','PhysicallyDeleteMails'):
        SetSingleConfigEntry(item)

    print '<body><p>OK, settings have been changed.</p>'
    print '[<a href="%s"> Back to main page  </a>]' % GenerateLink('mainframe')    
    print '</p></body></html>'

subject_tokens = [ ["!!",], ["!","free"], ["!","your"], ["!","you"], ["hosting"], ["money"], ["business"],
                   ["adult"], ["your","site"], ["-","$"], ["only",":"], ["!","website"], ["advertisement"],
                   ["software","free"],[".","$"],["your","web"],["!","this"],["link"],["search"],["home"],["amateur"],
                   ["more"],["engines"],["!","get"],["cash"],["marketing"],["sex"],["$$"],["!",".."],[".","free"],
                   ["!","software"],["million"],[":","ad"],["accept"],["cards"],["your site"],["webmaster"],
                   ["your","?"],["to","$"],["message"],["scouting"],["get","your"],["live"],["phone"],["!","site"],
                   ["your","free"],["!","now"],["send"],["$","free"],["-",".."],["mlm"],["advertising"],["you","..."],
                   ["your","website"],["!","new"],["$$$"],["....."],["do","you"],["??"],["!","hot"],["you","i"],["offer"],
                   ["your","traffic"],["your","$"],["in","$"],["don't"],["increase"],["know"],["per"],["income"],
                   ["fuckin"],["stock","alert"],["fortune"],["babes","love"],["hardcore"],["hello!"],["christmas"],
                   ["*~*~*"],["equities"],["lesbian"],["huge","cock"],["pussy"],["investment"],["vhs","dvd"],
                   ["growth","potential"],["crazy"],["$$$"],["investor","alert"],["tax","break"],["web","design"],
                   ["geschlecht"],["download"],["dildo"],["yen","market"],["prescription"],["adv:"],["adv."],
                   ["lolitas"],["domain"],["national"],["guide"],["celebrities"],["xxx"],["lawyer"],["great"],
                   ["huge"],["need","help"],["take","hard"],["video"],["interest"],["bulk"],["porn"],["breast"],
                   ["junk"],["holiday"],["merchant"],["anything","anyone"],["alleine?"],["erwachsen"],["tax"],
                   ["iso 9000"],["squirrel"],["attraction"],["..."],["hetero"],["amazing"],["blond"],["debt"],
                   ["believe"],["pocket"],["traffic"],["special","report"],["fellowship"],["stock"],["cigar"],
                   ["abbildung"],["casino"],["urgent"],["info","requested"],["vacation"],["free","fun"],
                   ["nude","pics"],["girls"],["naked"],["this","really","worked"],["sick","shit"]]


def IsSpamSubjectLine(subject):
    subject = subject.lower()
    weight = float(reduce(lambda x,y:x+y,map(ord,subject)))/len(subject)
    if weight > 128:
        return 1

    for token_tuple in subject_tokens:
        found = 0
        for token in token_tuple:
            if subject.find(token) >= 0:
                found += 1
        if found == len(token_tuple):
            return 1

    tokens = subject.split()
    try:
        isdigit = int(tokens[-1])
        isdigit = len(tokens[-1]) > 3
    except:
        isdigit = 0
    if isdigit:
        return 1

    return 0

def IsSpamLine(line):
    for item in ["as seen on national tv","erotik","undisclosed recipients"]:
        if line.find(item) > 0:
            return 1

def IsSpamMail(id,data):
    lines = data.split("\n")
    subject = None
    for line in lines:
        if line.strip() == "": break
        s = line.find(':')
        if s > 0:
            tokens = (line[:s],line[s:])
            keyword = tokens[0].lower()
            if keyword == 'subject':
                subject = tokens[1]
                if IsSpamSubjectLine(subject):
                    print '<input type="checkbox" name="ID%d" value="ON" checked>%s<br>' % (id,subject)
                    return 1

        if IsSpamLine(line.lower()):
            print '<input type="checkbox" name="ID%d" value="ON" checked>%s<br>' % (id,subject)
            return 1
    return 0

def FilterSpamMessagesOK():
    userid = args["userid"]
    print "userid=",userid
    print "<pre>"
    for item in form.keys():
        name = str(item)
        if name[:2] == "ID":
            try:                
                msgid = int(name[2:])
                body = maildb.DbQuery("SELECT BODY FROM messages WHERE ID=%d AND UID=%d" % (msgid,userid))[0][0]
                #print "removing", body
                #os.remove(body)                
                maildb.DbCommit("DELETE FROM messages WHERE UID=%d AND ID=%d" % (userid,msgid))
            except:
                traceback.print_exc()
    print '</pre><p>Done. <a href="%s">Click here to go back to spam list</a>.</p>' % GenerateLink("FilterSpam",userid)

def DoesFileExist(filename):
    try:
        file = open(MAP_ROOT_NAME(filename))
        file.close()
        return 1
    except:
        return 0

def FilterSpam():
    userid = args["userid"]
    messages = maildb.DbQuery("SELECT * FROM messages WHERE UID=%d" % userid)
    print '<form name="f" method="POST" action="ShicksAdmin.py">'
    count = 0
    for message in messages:
        filename = message[2]

        if not DoesFileExist(filename):
            print "file", filename, "does not exist !!!"
            maildb.DbCommit("DELETE FROM messages WHERE ID=%d" % message[0])
            continue
            
        try:
            file = open(MAP_ROOT_NAME(filename))
        except:
            file = None
        if file is not None:        
            data = file.read(2000)
            file.close()
            if IsSpamMail(message[0],data):
                count += 1
                if count == 60:
                    print "<p>more than 60 spam mails detected. Please retry after purging entries.</p>"
                    break
    if count:
        print '<INPUT type=hidden value="%s" name=code>' % GenerateLinkData("FilterSpamMessagesOK",userid)
        print '<p><input type="submit" value="Delete marked messages" name="DeleteMessages"></form></p>'
    else:
        print "</form><h2>You are lucky! Your inbox doesn't contain any spam messages.</h2>"
    print '<p>[<a href="%s"> Go back to user list </a>]</p>' % GenerateLink("ListAllUsers")

def GetArguments(form):
    global USE_ENCODED_URLS
    result = None
    if form.has_key('code'):        
        try:
            if USE_ENCODED_URLS:
                result = eval(binascii.a2b_hex(form['code'].value))
            else:
                result = eval(form['code'].value)
        except:
            pass
    return result

form = cgi.FieldStorage()
args = GetArguments(form)
if args is None:
    args = { 'action': 'mainframe' }

action = args['action']
functions = {
    'mainframe' : GenerateTitlePage,
    'ListAllUsers': ListAllUsers,
    'DescribeUserByID': DescribeUserByID,
    'ChangePasswordForUserID': ChangePasswordForUserID,
    'ChangePasswordForUserIDOK': ChangePasswordForUserIDOK,
    'ChangeNameForUserID': ChangeNameForUserID,
    'ChangeNameForUserIDOK': ChangeNameForUserIDOK,
    'CreateNewUser': CreateNewUser,
    'CreateNewUserOK': CreateNewUserOK,
    'AddEmailForUserID': AddEmailForUserID,
    'AddEmailForUserIDOK': AddEmailForUserIDOK,
    'AddUserForwardID': AddUserForwardID,
    'AddUserForwardIDOK': AddUserForwardIDOK,
    'CreateMailingList': CreateMailingList,
    'CreateMailingListOK': CreateMailingListOK,
    'ChangeEmailAddress': ChangeEmailAddress,
    'ChangeEmailAddressOK': ChangeEmailAddressOK,
    'DeleteEmailAddress': DeleteEmailAddress,
    'DeleteEmailAddressOK': DeleteEmailAddressOK,
    'AddMailingListMember': AddMailingListMember,
    'AddMailingListMemberOK': AddMailingListMemberOK,
    'SiteConfiguration': SiteConfiguration,
    'SiteConfigurationOK' : SiteConfigurationOK,
    'DeleteUserByID': DeleteUserByID,
    'DeleteUserByIDOK': DeleteUserByIDOK,
    'RemoveForwardID': RemoveForwardID,
    'RemoveForwardIDOK': RemoveForwardIDOK,
    'ShowPlainTextMessage': ShowPlainTextMessage,
    'DisplayMessageRange': DisplayMessageRange,
    'ResendOrDeleteMessage': ResendOrDeleteMessage,
    'DeleteMessageOK': DeleteMessageOK,
    'DisplayMessagesForList': DisplayMessagesForList,
    'FilterSpam': FilterSpam,
    'FilterSpamMessagesOK': FilterSpamMessagesOK
    }

functions[action]()
